import { MongoDbFilter } from './mongoDbFilter';
import { MongoDbProjection } from './mongoDbProjection';
import { MongoDbSort } from "./mongoDbSort";
import { GraphQLResolveInfo, GraphQLFieldResolver, GraphQLObjectType, GraphQLInputObjectType } from 'graphql';
export interface QueryCallback<TSource, TContext> {
    (filter: MongoDbFilter, projection: MongoDbProjection, options: MongoDbOptions, source: TSource, args: {
        [argName: string]: any;
    }, context: TContext, info: GraphQLResolveInfo): Promise<any>;
}
export interface MongoDbOptions {
    sort?: MongoDbSort;
    limit?: number;
    skip?: number;
    projection?: MongoDbProjection;
}
export interface QueryOptions {
    differentOutputType?: boolean;
}
export declare function getMongoDbQueryResolver<TSource, TContext>(graphQLType: GraphQLObjectType, queryCallback: QueryCallback<TSource, TContext>, queryOptions?: QueryOptions): GraphQLFieldResolver<TSource, TContext>;
export declare function getGraphQLQueryArgs(graphQLType: GraphQLObjectType): {
    [key: string]: {
        type: GraphQLInputObjectType;
    };
} & {
    filter: {
        type: GraphQLInputObjectType;
    };
    sort: {
        type: GraphQLInputObjectType;
    };
    pagination: {
        type: GraphQLInputObjectType;
    };
};
